const Main = imports.ui.main;
const Lang = imports.lang;
const PanelMenu = imports.ui.panelMenu;
const UserMenu = imports.ui.userMenu;

function QuitButton() {
    this._init.apply(this, arguments);
}

QuitButton.prototype = {
	__proto__: PanelMenu.SystemStatusButton.prototype,
    
	_init: function() {		
		this.userMenuButtonBox = Main.panel._statusArea['userMenu'].menu.box;
		this.items = this.userMenuButtonBox.get_children();

	        PanelMenu.SystemStatusButton.prototype._init.call(this, 'system-shutdown');
    		
		for (i=4 ; i<this.items.length; i++)
		{
			let item = this.items[i];
			item.reparent(this.menu.box);
			item._delegate.connect('activate', Lang.bind(this, function() { this.menu.close(); }));
		}
	},
	
	removeMenu: function(){
		let children = this.menu.box.get_children();
		for (i=0 ; i<children.length; i++) children[i].reparent(this.userMenuButtonBox);
	}
}

function init() {}

function enable() {
	_QuitButton = new QuitButton;
	Main.panel.addToStatusArea('system-shutdown', _QuitButton, 100);	// hack, I know…
	Main.panel._statusArea['userMenu']._name.hide();
}

function disable() {
	_QuitButton.removeMenu();
	Main.panel._statusArea['userMenu']._name.show();
	_QuitButton.destroy();
}
